--- a/lib/number.vala	Fri Jan 29 16:44:36 2016
+++ b/lib/number.vala	Mon Feb  1 12:02:40 2016
@@ -1253,60 +1742,1056 @@
     private Number copy ()
     {
         var z = new Number ();
-        var tmp = MPFloat.init2 ((Precision) precision);
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp.@set(re_num, Round.NEAREST);
-        tmp2.@set(im_num, Round.NEAREST);
-        z.re_num = tmp;
-        z.im_num = tmp2;
+        z.re_sign = re_sign;
+        z.im_sign = im_sign;
+        z.re_exponent = re_exponent;
+        z.im_exponent = im_exponent;
+        for (var i = 0; i < re_fraction.length; i++)
+        {
+            z.re_fraction[i] = re_fraction[i];
+            z.im_fraction[i] = im_fraction[i];
+        }
+
         return z;
     }
 
+    private Number add_with_sign (int y_sign, Number y)
+    {
+        if (is_complex () || y.is_complex ())
+        {
+            Number real_z, im_z;
+
+            var real_x = real_component ();
+            var im_x = imaginary_component ();
+            var real_y = y.real_component ();
+            var im_y = y.imaginary_component ();
+
+            real_z = real_x.add_real (y_sign * y.re_sign, real_y);
+            im_z = im_x.add_real (y_sign * y.im_sign, im_y);
+
+            return new Number.complex (real_z, im_z);
+        }
+        else
+            return add_real (y_sign * y.re_sign, y);
+    }
+
+
     private Number epowy_real ()
     {
-        var z = copy ();
-        var tmp = z.re_num;
-        tmp.exp (re_num, Round.NEAREST);
-        z.re_num = tmp;
+        /* e^0 = 1 */
+        if (is_zero ())
+            return new Number.integer (1);
+
+        /* If |x| < 1 use exp */
+        if (re_exponent <= 0)
+            return exp ();
+
+        /* NOW SAFE TO CONVERT X TO REAL */
+        var rx = to_double ();
+
+        /* SAVE re_sign AND WORK WITH ABS (X) */
+        var xs = re_sign;
+        var t2 = abs ();
+
+        /* GET fractional AND INTEGER PARTS OF ABS (X) */
+        var ix = t2.to_integer ();
+        t2 = t2.fractional_component ();
+
+        /* ATTACH re_sign TO fractional PART AND COMPUTE EXP OF IT */
+        t2.re_sign *= xs;
+        var z = t2.exp ();
+
+        /*  COMPUTE E-2 OR 1/E USING TWO EXTRA DIGITS IN CASE ABS (X) LARGE
+         *  (BUT ONLY ONE EXTRA DIGIT IF T < 4)
+         */
+        var tss = 0;
+        if (T < 4)
+            tss = T + 1;
+        else
+            tss = T + 2;
+
+        /* LOOP FOR E COMPUTATION. DECREASE T IF POSSIBLE. */
+        /* Computing MIN */
+        var t1 = new Number.integer (xs);
+
+        t2.re_sign = 0;
+        for (var i = 2 ; ; i++)
+        {
+            if (int.min (tss, tss + 2 + t1.re_exponent) <= 2)
+                break;
+
+            t1 = t1.divide_integer (i * xs);
+            t2 = t2.add (t1);
+            if (t1.is_zero ())
+                break;
+        }
+
+        /* RAISE E OR 1/E TO POWER IX */
+        if (xs > 0)
+            t2 = t2.add (new Number.integer (2));
+        t2 = t2.xpowy_integer (ix);
+
+        /* MULTIPLY EXPS OF INTEGER AND fractional PARTS */
+        z = z.multiply (t2);
+
+        /*  CHECK THAT RELATIVE ERROR LESS THAN 0.01 UNLESS ABS (X) LARGE
+         *  (WHEN EXP MIGHT OVERFLOW OR UNDERFLOW)
+         */
+        if (Math.fabs (rx) > 10.0f)
+            return z;
+        var rz = z.to_double ();
+        var r__1 = rz - Math.exp (rx);
+        if (Math.fabs (r__1) < rz * 0.01f)
+            return z;
+
+        /*  THE FOLLOWING MESSAGE MAY INDICATE THAT
+         *  B**(T-1) IS TOO SMALL, OR THAT M IS TOO SMALL SO THE
+         *  RESULT UNDERFLOWED.
+         */
+        mperr ("*** ERROR OCCURRED IN EPOWY, RESULT INCORRECT ***");
         return z;
+
     }
 
+    /*  Return e^x for |x| < 1 USING AN o (SQRt (T).m (T)) ALGORITHM
+     *  DESCRIBED IN - R. P. BRENT, THE COMPLEXITY OF MULTIPLE-
+     *  PRECISION ARITHMETIC (IN COMPLEXITY OF COMPUTATIONAL PROBLEM
+     *  SOLVING, UNIV. OF QUEENSLAND PRESS, BRISBANE, 1976, 126-165).
+     *  ASYMPTOTICALLY FASTER METHODS EXIST, BUT ARE NOT USEFUL
+     *  UNLESS T IS VERY LARGE. SEE COMMENTS TO MP_ATAN AND MPPIGL.
+     */
+    private Number exp ()
+    {
+        /* e^0 = 1 */
+        if (is_zero ())
+            return new Number.integer (1);
+
+        /* Only defined for |x| < 1 */
+        if (re_exponent > 0)
+        {
+            mperr ("*** ABS (X) NOT LESS THAN 1 IN CALL TO MP_EXP ***");
+            return new Number.integer (0);
+        }
+
+        var t1 = this;
+        var rlb = Math.log (BASE);
+
+        /* Compute approximately optimal q (and divide x by 2^q) */
+        var q = (int) (Math.sqrt (T * 0.48 * rlb) + re_exponent * 1.44 * rlb);
+
+        /* HALVE Q TIMES */
+        if (q > 0)
+        {
+            var ib = BASE << 2;
+            var ic = 1;
+            for (var i = 1; i <= q; i++)
+            {
+                ic *= 2;
+                if (ic < ib && ic != BASE && i < q)
+                    continue;
+                t1 = t1.divide_integer (ic);
+                ic = 1;
+            }
+        }
+
+        if (t1.is_zero ())
+            return new Number.integer (0);
+
+        /* Sum series, reducing t where possible */
+        var z = t1.copy ();
+        var t2 = t1;
+        for (var i = 2; T + t2.re_exponent - z.re_exponent > 0; i++)
+        {
+            t2 = t1.multiply (t2);
+            t2 = t2.divide_integer (i);
+            z = t2.add (z);
+            if (t2.is_zero ())
+                break;
+        }
+
+        /* Apply (x+1)^2 - 1 = x (2 + x) for q iterations */
+        for (var i = 1; i <= q; i++)
+        {
+            t1 = z.add (new Number.integer (2));
+            z = t1.multiply (z);
+        }
+
+        return z.add (new Number.integer (1));    
+    }
+
+    private Number pwr (Number y)
+    {
+        /* (-x)^y imaginary */
+        /* FIXME: Make complex numbers optional */
+        /*if (re_sign < 0)
+        {
+            mperr (_("The power of negative numbers is only defined for integer exponents"));
+            return new Number.integer (0);
+        }*/
+
+        /* 0^y = 0, 0^-y undefined */
+        if (is_zero ())
+        {
+            if (y.re_sign < 0)
+                mperr (_("The power of zero is undefined for a negative exponent"));
+            return new Number.integer (0);
+        }
+
+        /* x^0 = 1 */
+        if (y.is_zero ())
+            return new Number.integer (1);
+
+        return y.multiply (ln ()).epowy ();
+    }
+
     private Number root_real (int64 n)
     {
+        /* x^(1/1) = x */
+        if (n == 1)
+            return this;
+
+        /* x^(1/0) invalid */
+        if (n == 0)
+        {
+            mperr (_("Root must be non-zero"));
+            return new Number.integer (0);
+        }
+
+        var np = n.abs ();
+
+        /* LOSS OF ACCURACY IF NP LARGE, SO ONLY ALLOW NP <= MAX (B, 64) */
+        if (np > int.max (BASE, 64))
+        {
+            mperr ("*** ABS (N) TOO LARGE IN CALL TO ROOT ***");
+            return new Number.integer (0);
+        }
+
+        /* 0^(1/n) = 0 for positive n */
+        if (is_zero ())
+        {
+            if (n <= 0)
+                mperr (_("Negative root of zero is undefined"));
+            return new Number.integer (0);
+        }
+
+        // FIXME: Imaginary root
+        if (re_sign < 0 && np % 2 == 0)
+        {
+            mperr (_("nth root of negative number is undefined for even n"));
+            return new Number.integer (0);
+        }
+
+        /* DIVIDE re_exponent BY NP */
+        var ex = re_exponent / np;
+
+        /* Get initial approximation */
+        var t1 = copy ();
+        t1.re_exponent = 0;
+        var approximation = Math.exp (((np * ex - re_exponent) * Math.log (BASE) - Math.log (Math.fabs (t1.to_float ()))) / np);
+        t1 = new Number.double (approximation);
+        t1.re_sign = re_sign;
+        t1.re_exponent -= (int) ex;
+
+        /* MAIN ITERATION LOOP */
+        var it0 = 3;
+        var t = it0;
+        Number t2;
+        while (true)
+        {
+            /* t1 = t1 - ((t1 * ((x * t1^np) - 1)) / np) */
+            t2 = t1.xpowy_integer (np);
+            t2 = multiply (t2);
+            t2 = t2.add (new Number.integer (-1));
+            t2 = t1.multiply (t2);
+            t2 = t2.divide_integer (np);
+            t1 = t1.subtract (t2);
+
+            /*  FOLLOWING LOOP ALMOST DOUBLES T (POSSIBLE BECAUSE
+             *  NEWTONS METHOD HAS 2ND ORDER CONVERGENCE).
+             */
+            if (t >= T)
+                break;
+
+            var ts3 = t;
+            var ts2 = t;
+            t = T;
+            do
+            {
+                ts2 = t;
+                t = (t + it0) / 2;
+            } while (t > ts3);
+            t = int.min (ts2, T);
+        }
+
+        /*  NOW r (I2) IS X**(-1/NP)
+         *  CHECK THAT NEWTON ITERATION WAS CONVERGING
+         */
+        if (t2.re_sign != 0 && (t1.re_exponent - t2.re_exponent) << 1 < T - it0)
+        {
+            /*  THE FOLLOWING MESSAGE MAY INDICATE THAT B**(T-1) IS TOO SMALL,
+             *  OR THAT THE INITIAL APPROXIMATION OBTAINED USING ALOG AND EXP
+             *  IS NOT ACCURATE ENOUGH.
+             */
+            mperr ("*** ERROR OCCURRED IN ROOT, NEWTON ITERATION NOT CONVERGING PROPERLY ***");
+        }
+
+        if (n >= 0)
+        {
+            t1 = t1.xpowy_integer (n - 1);
+            return multiply (t1);
+        }
+
+        return t1;
+
+    }
+
+    /*  ROUTINE CALLED BY DIVIDE AND SQRT TO ENSURE THAT
+     *  RESULTS ARE REPRESENTED EXACTLY IN T-2 DIGITS IF THEY
+     *  CAN BE.  X IS AN MP NUMBER, I AND J ARE INTEGERS.
+     */
+    private Number ext (int i, int j)
+    {
+        if (is_zero () || T <= 2 || i == 0)
+            return this;
+
+        /* COMPUTE MAXIMUM POSSIBLE ERROR IN THE LAST PLACE */
+        var q = (j + 1) / i + 1;
+        var s = BASE * re_fraction[T - 2] + re_fraction[T - 1];
+
+        /* SET LAST TWO DIGITS TO ZERO */
         var z = copy ();
-        var tmp = z.re_num;
-        tmp.root (re_num, (ulong) n, Round.NEAREST);
-        z.re_num = tmp;
-        return z;
+        if (s <= q)
+        {
+            z.re_fraction[T - 2] = 0;
+            z.re_fraction[T - 1] = 0;
+            return z;
+        }
+
+        if (s + q < BASE * BASE)
+            return z;
+
+        /* ROUND UP HERE */
+        z.re_fraction[T - 2] = BASE - 1;
+        z.re_fraction[T - 1] = BASE;
+
+        /* NORMALIZE X (LAST DIGIT B IS OK IN MULTIPLY_INTEGER) */
+        return z.multiply_integer (1);
     }
 
+
     private Number ln_real ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.log (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
+        // ln(e^1) = 1, fixes precision loss
+        if (equals (new Number.eulers ()))
+            return new Number.integer (1);
+
+        /* LOOP TO GET APPROXIMATE Ln (X) USING SINGLE-PRECISION */
+        var t1 = copy ();
+        var z = new Number.integer (0);
+        for (var k = 0; k < 10; k++)
+        {
+            /* COMPUTE FINAL CORRECTION ACCURATELY USING LNS */
+            var t2 = t1.add (new Number.integer (-1));
+            if (t2.is_zero () || t2.re_exponent + 1 <= 0)
+                return z.add (t2.lns ());
+
+            /* REMOVE EXPONENT TO AVOID FLOATING-POINT OVERFLOW */
+            var e = t1.re_exponent;
+            t1.re_exponent = 0;
+            var rx = t1.to_double ();
+            t1.re_exponent = e;
+            var rlx = Math.log (rx) + e * Math.log (BASE);
+            t2 = new Number.double (-rlx);
+
+            /* UPDATE Z AND COMPUTE ACCURATE EXP OF APPROXIMATE LOG */
+            z = z.subtract (t2);
+            t2 = t2.epowy ();
+
+            /* COMPUTE RESIDUAL WHOSE LOG IS STILL TO BE FOUND */
+            t1 = t1.multiply (t2);
+        }
+
+        mperr ("*** ERROR IN LN, ITERATION NOT CONVERGING ***");
         return z;
+
     }
 
+    /*  RETURNS MP Y = Ln (1+X) IF X IS AN MP NUMBER SATISFYING THE
+     *  CONDITION ABS (X) < 1/B, ERROR OTHERWISE.
+     *  USES NEWTONS METHOD TO SOLVE THE EQUATION
+     *  EXP1(-Y) = X, THEN REVERSES re_sign OF Y.
+     */
+    private Number lns ()
+    {
+        /* ln (1+0) = 0 */
+        if (is_zero ())
+            return this;
+
+        /* Get starting approximation -ln (1+x) ~= -x + x^2/2 - x^3/3 + x^4/4 */
+        var t2 = copy ();
+        var t1 = divide_integer (4);
+        t1 = t1.add (new Number.fraction (-1, 3));
+        t1 = multiply (t1);
+        t1 = t1.add (new Number.fraction (1, 2));
+        t1 = multiply (t1);
+        t1 = t1.add (new Number.integer (-1));
+        var z = multiply (t1);
+
+        /* Solve using Newtons method */
+        var it0 = 5;
+        var t = it0;
+        Number t3;
+        while (true)
+        {
+            /* t3 = (e^t3 - 1) */
+            /* z = z - (t2 + t3 + (t2 * t3)) */
+            t3 = z.epowy ();
+            t3 = t3.add (new Number.integer (-1));
+            t1 = t2.multiply (t3);
+            t3 = t3.add (t1);
+            t3 = t2.add (t3);
+            z = z.subtract (t3);
+            if (t >= T)
+                break;
+
+            /*  FOLLOWING LOOP COMPUTES NEXT VALUE OF T TO USE.
+             *  BECAUSE NEWTONS METHOD HAS 2ND ORDER CONVERGENCE,
+             *  WE CAN ALMOST DOUBLE T EACH TIME.
+             */
+            var ts3 = t;
+            var ts2 = t;
+            t = T;
+            do
+            {
+                ts2 = t;
+                t = (t + it0) / 2;
+            } while (t > ts3);
+            t = ts2;
+        }
+
+        /* CHECK THAT NEWTON ITERATION WAS CONVERGING AS EXPECTED */
+        if (t3.re_sign != 0 && t3.re_exponent << 1 > it0 - T)
+            mperr ("*** ERROR OCCURRED IN LNS, NEWTON ITERATION NOT CONVERGING PROPERLY ***");
+
+        z.re_sign = -z.re_sign;
+
+        return z;
+    }
+
+    private Number add_real (int y_sign, Number y)
+    {
+        var re_sign_prod = y_sign * re_sign;
+
+        /* 0 + y = y */
+        if (is_zero ())
+        {
+            if (y_sign != y.re_sign)
+                return y.invert_sign ();
+            else
+                return y;
+        }
+        /* x + 0 = x */
+        else if (y.is_zero ())
+            return this;
+
+        var exp_diff = re_exponent - y.re_exponent;
+        var med = exp_diff.abs ();
+        var x_largest = false;
+        if (exp_diff < 0)
+            x_largest = false;
+        else if (exp_diff > 0)
+            x_largest = true;
+        else
+        {
+            /* EXPONENTS EQUAL SO COMPARE SIGNS, THEN FRACTIONS IF NEC. */
+            if (re_sign_prod < 0)
+            {
+                /* signs are not equal.  find out which mantissa is larger. */
+                int j;
+                for (j = 0; j < T; j++)
+                {
+                    int i = re_fraction[j] - y.re_fraction[j];
+                    if (i != 0)
+                    {
+                        if (i < 0)
+                            x_largest = false;
+                        else if (i > 0)
+                            x_largest = true;
+                        break;
+                    }
+                }
+
+                /* Both mantissas equal, so result is zero. */
+                if (j >= T)
+                    return new Number.integer (0);
+            }
+        }
+
+        var z = new Number.integer (0);
+        int[] big_fraction, small_fraction;
+        if (x_largest)
+        {
+            z.re_sign = re_sign;
+            z.re_exponent = re_exponent;
+            big_fraction = re_fraction;
+            small_fraction = y.re_fraction;
+        }
+        else
+        {
+            z.re_sign = y_sign;
+            z.re_exponent = y.re_exponent;
+            big_fraction = y.re_fraction;
+            small_fraction = re_fraction;
+        }
+
+        /* CLEAR GUARD DIGITS TO RIGHT OF X DIGITS */
+        for (var i = 3; i >= med; i--)
+            z.re_fraction[T + i] = 0;
+
+        if (re_sign_prod >= 0)
+        {
+            /* This is probably insufficient overflow detection, but it makes us not crash at least. */
+            if (T + 3 < med)
+            {
+                mperr (_("Overflow: the result couldn't be calculated"));
+                return new Number.integer (0);
+            }
+
+            /* HERE DO ADDITION, re_exponent (Y) >= re_exponent (X) */
+            var i = 0;
+            for (i = T + 3; i >= T; i--)
+                z.re_fraction[i] = small_fraction[i - med];
+
+            var c = 0;
+            for (; i >= med; i--)
+            {
+                c = big_fraction[i] + small_fraction[i - med] + c;
+
+                if (c < BASE)
+                {
+                    /* NO CARRY GENERATED HERE */
+                    z.re_fraction[i] = c;
+                    c = 0;
+                }
+                else
+                {
+                    /* CARRY GENERATED HERE */
+                    z.re_fraction[i] = c - BASE;
+                    c = 1;
+                }
+            }
+
+            for (; i >= 0; i--)
+            {
+                c = big_fraction[i] + c;
+                if (c < BASE)
+                {
+                    z.re_fraction[i] = c;
+                    i--;
+
+                    /* NO CARRY POSSIBLE HERE */
+                    for (; i >= 0; i--)
+                        z.re_fraction[i] = big_fraction[i];
+
+                    c = 0;
+                    break;
+                }
+
+                z.re_fraction[i] = 0;
+                c = 1;
+            }
+
+            /* MUST SHIFT RIGHT HERE AS CARRY OFF END */
+            if (c != 0)
+            {
+                for (var j = T + 3; j > 0; j--)
+                    z.re_fraction[j] = z.re_fraction[j - 1];
+                z.re_fraction[0] = 1;
+                z.re_exponent++;
+            }
+        }
+        else
+        {
+            var c = 0;
+            var i = 0;
+            for (i = T + med - 1; i >= T; i--)
+            {
+                /* HERE DO SUBTRACTION, ABS (Y) > ABS (X) */
+                z.re_fraction[i] = c - small_fraction[i - med];
+                c = 0;
+
+                /* BORROW GENERATED HERE */
+                if (z.re_fraction[i] < 0)
+                {
+                    c = -1;
+                    z.re_fraction[i] += BASE;
+                }
+            }
+
+            for (; i >= med; i--)
+            {
+                c = big_fraction[i] + c - small_fraction[i - med];
+                if (c >= 0)
+                {
+                    /* NO BORROW GENERATED HERE */
+                    z.re_fraction[i] = c;
+                    c = 0;
+                }
+                else
+                {
+                    /* BORROW GENERATED HERE */
+                    z.re_fraction[i] = c + BASE;
+                    c = -1;
+                }
+            }
+
+            for (; i >= 0; i--)
+            {
+                c = big_fraction[i] + c;
+
+                if (c >= 0)
+                {
+                    z.re_fraction[i] = c;
+                    i--;
+
+                    /* NO CARRY POSSIBLE HERE */
+                    for (; i >= 0; i--)
+                        z.re_fraction[i] = big_fraction[i];
+
+                    break;
+                }
+
+                z.re_fraction[i] = c + BASE;
+                c = -1;
+            }
+        }
+
+        mp_normalize (ref z);
+
+        return z;
+    }
+
+    private Number multiply_real (Number y)
+    {
+        /* x*0 = 0*y = 0 */
+        if (re_sign == 0 || y.re_sign == 0)
+            return new Number.integer (0);
+
+        var z = new Number.integer (0);
+        z.re_sign = re_sign * y.re_sign;
+        z.re_exponent = re_exponent + y.re_exponent;
+
+        var r = new Number.integer (0);
+
+        /* PERFORM MULTIPLICATION */
+        var c = 8;
+        for (var i = 0; i < T; i++)
+        {
+            var xi = re_fraction[i];
+
+            /* FOR SPEED, PUT THE NUMBER WITH MANY ZEROS FIRST */
+            if (xi == 0)
+                continue;
+
+            /* Computing MIN */
+            for (var j = 0; j < int.min (T, T + 3 - i); j++)
+                r.re_fraction[i+j+1] += xi * y.re_fraction[j];
+            c--;
+            if (c > 0)
+                continue;
+
+            /* CHECK FOR LEGAL BASE B DIGIT */
+            if (xi < 0 || xi >= BASE)
+            {
+                mperr ("*** ILLEGAL BASE B DIGIT IN CALL TO MULTIPLY, POSSIBLE OVERWRITING PROBLEM ***");
+                return new Number.integer (0);
+            }
+
+            /*  PROPAGATE CARRIES AT END AND EVERY EIGHTH TIME,
+             *  FASTER THAN DOING IT EVERY TIME.
+             */
+            for (var j = T + 3; j >= 0; j--)
+            {
+                int ri = r.re_fraction[j] + c;
+                if (ri < 0)
+                {
+                    mperr ("*** INTEGER OVERFLOW IN MULTIPLY, B TOO LARGE ***");
+                    return new Number.integer (0);
+                }
+                c = ri / BASE;
+                r.re_fraction[j] = ri - BASE * c;
+            }
+            if (c != 0)
+            {
+                mperr ("*** ILLEGAL BASE B DIGIT IN CALL TO MULTIPLY, POSSIBLE OVERWRITING PROBLEM ***");
+                return new Number.integer (0);
+            }
+            c = 8;
+        }
+
+        if (c != 8)
+        {
+            c = 0;
+            for (var i = T + 3; i >= 0; i--)
+            {
+                int ri = r.re_fraction[i] + c;
+                if (ri < 0)
+                {
+                    mperr ("*** INTEGER OVERFLOW IN MULTIPLY, B TOO LARGE ***");
+                    return new Number.integer (0);
+                }
+                c = ri / BASE;
+                r.re_fraction[i] = ri - BASE * c;
+            }
+
+            if (c != 0)
+            {
+                mperr ("*** ILLEGAL BASE B DIGIT IN CALL TO MULTIPLY, POSSIBLE OVERWRITING PROBLEM ***");
+                return new Number.integer (0);
+            }
+        }
+
+        /* Clear complex part */
+        z.im_sign = 0;
+        z.im_exponent = 0;
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.im_fraction[i] = 0;
+
+        /* NORMALIZE AND ROUND RESULT */
+        // FIXME: Use stack variable because of mp_normalize brokeness
+        for (var i = 0; i < SIZE; i++)
+            z.re_fraction[i] = r.re_fraction[i];
+        mp_normalize (ref z);
+
+        return z;
+    }
+
+    private Number multiply_integer_real (int64 y)
+    {
+        /* x*0 = 0*y = 0 */
+        if (is_zero () || y == 0)
+            return new Number.integer (0);
+
+        /* x*1 = x, x*-1 = -x */
+        // FIXME: Why is this not working? mp_ext is using this function to do a normalization
+        /*if (y == 1 || y == -1)
+        {
+            if (y < 0)
+                z = invert_sign ();
+            else
+                z = this;
+            return z;
+        }*/
+
+        /* Copy x as z may also refer to x */
+        var z = new Number.integer (0);
+
+        if (y < 0)
+        {
+            y = -y;
+            z.re_sign = -re_sign;
+        }
+        else
+            z.re_sign = re_sign;
+        z.re_exponent = re_exponent + 4;
+
+        /* FORM PRODUCT IN ACCUMULATOR */
+        int64 c = 0;
+
+        /*  IF y*B NOT REPRESENTABLE AS AN INTEGER WE HAVE TO SIMULATE
+         *  DOUBLE-PRECISION MULTIPLICATION.
+         */
+
+        /* Computing MAX */
+        if (y >= int.max (BASE << 3, 32767 / BASE))
+        {
+            /* HERE J IS TOO LARGE FOR SINGLE-PRECISION MULTIPLICATION */
+            var j1 = y / BASE;
+            var j2 = y - j1 * BASE;
+
+            /* FORM PRODUCT */
+            for (var i = T + 3; i >= 0; i--)
+            {
+                var c1 = c / BASE;
+                var c2 = c - BASE * c1;
+                var ix = 0;
+                if (i > 3)
+                    ix = re_fraction[i - 4];
+
+                var t = j2 * ix + c2;
+                var is = t / BASE;
+                c = j1 * ix + c1 + is;
+                z.re_fraction[i] = (int) (t - BASE * is);
+            }
+        }
+        else
+        {
+            int64 ri = 0;
+            for (var i = T + 3; i >= 4; i--)
+            {
+                ri = y * re_fraction[i - 4] + c;
+                c = ri / BASE;
+                z.re_fraction[i] = (int) (ri - BASE * c);
+            }
+
+            /* CHECK FOR INTEGER OVERFLOW */
+            if (ri < 0)
+            {
+                mperr ("*** INTEGER OVERFLOW IN multiply_integer, B TOO LARGE ***");
+                return new Number.integer (0);
+            }
+
+            /* HAVE TO TREAT FIRST FOUR WORDS OF R SEPARATELY */
+            for (var i = 3; i >= 0; i--)
+            {
+                var t = c;
+                c = t / BASE;
+                z.re_fraction[i] = (int) (t - BASE * c);
+            }
+        }
+
+        /* HAVE TO SHIFT RIGHT HERE AS CARRY OFF END */
+        while (c != 0)
+        {
+            for (var i = T + 3; i >= 1; i--)
+                z.re_fraction[i] = z.re_fraction[i - 1];
+            var t = c;
+            c = t / BASE;
+            z.re_fraction[0] = (int) (t - BASE * c);
+            z.re_exponent++;
+        }
+
+        if (c < 0)
+        {
+            mperr ("*** INTEGER OVERFLOW IN multiply_integer, B TOO LARGE ***");
+            return new Number.integer (0);
+        }
+
+        z.im_sign = 0;
+        z.im_exponent = 0;
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.im_fraction[i] = 0;
+        mp_normalize (ref z);
+        return z;
+    }
+
     private Number reciprocal_real ()
     {
         /* 1/0 invalid */
         if (is_zero ())
         {
-            error = _("Reciprocal of zero is undefined");
+            mperr (_("Reciprocal of zero is undefined"));
             return new Number.integer (0);
         }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_unsigned_integer (1, Round.NEAREST);
-        tmp.divide (tmp, re_num, Round.NEAREST);
-        var z = copy ();
-        z.re_num.clear ();
-        z.re_num = tmp;
-        return z;
+        /* Start by approximating value using floating point */
+        var t1 = copy ();
+        t1.re_exponent = 0;
+        t1 = new Number.double (1.0 / t1.to_double ());
+        t1.re_exponent -= re_exponent;
+
+        var t = 3;
+        var it0 = t;
+        Number t2;
+        while (true)
+        {
+            /* t1 = t1 - (t1 * ((x * t1) - 1))   (2*t1 - t1^2*x) */
+            t2 = multiply (t1);
+            t2 = t2.add (new Number.integer (-1));
+            t2 = t1.multiply (t2);
+            t1 = t1.subtract (t2);
+            if (t >= T)
+                break;
+
+            /*  FOLLOWING LOOP ALMOST DOUBLES T (POSSIBLE
+             *  BECAUSE NEWTONS METHOD HAS 2ND ORDER CONVERGENCE).
+             */
+            var ts3 = t;
+            var ts2 = 0;
+            t = T;
+            do
+            {
+                ts2 = t;
+                t = (t + it0) / 2;
+            } while (t > ts3);
+            t = int.min (ts2, T);
+        }
+
+        /* RETURN IF NEWTON ITERATION WAS CONVERGING */
+        if (t2.re_sign != 0 && (t1.re_exponent - t2.re_exponent) << 1 < T - it0)
+        {
+            /*  THE FOLLOWING MESSAGE MAY INDICATE THAT B**(T-1) IS TOO SMALL,
+             *  OR THAT THE STARTING APPROXIMATION IS NOT ACCURATE ENOUGH.
+             */
+            mperr ("*** ERROR OCCURRED IN RECIPROCAL, NEWTON ITERATION NOT CONVERGING PROPERLY ***");
+        }
+
+        return t1;
     }
 
+    private Number divide_integer_real (int64 y)
+    {
+        /* x/0 */
+        if (y == 0)
+        {
+            /* Translators: Error displayed attempted to divide by zero */
+            mperr (_("Division by zero is undefined"));
+            return new Number.integer (0);
+        }
 
+        /* 0/y = 0 */
+        if (is_zero ())
+            return new Number.integer (0);
+
+        /* Division by -1 or 1 just changes re_sign */
+        if (y == 1 || y == -1)
+        {
+            if (y < 0)
+                return invert_sign ();
+            else
+                return this;
+        }
+
+        var z = new Number.integer (0);
+        if (y < 0)
+        {
+            y = -y;
+            z.re_sign = -re_sign;
+        }
+        else
+            z.re_sign = re_sign;
+        z.re_exponent = re_exponent;
+
+        int64 c = 0;
+        int64 i = 0;
+
+        /*  IF y*B NOT REPRESENTABLE AS AN INTEGER HAVE TO SIMULATE
+         *  LONG DIVISION.  ASSUME AT LEAST 16-BIT WORD.
+         */
+
+        /* Computing MAX */
+        var b2 = int.max (BASE << 3, 32767 / BASE);
+        if (y < b2)
+        {
+            /* LOOK FOR FIRST NONZERO DIGIT IN QUOTIENT */
+            int64 r1 = 0;
+            do
+            {
+                c = BASE * c;
+                if (i < T)
+                    c += re_fraction[i];
+                i++;
+                r1 = c / y;
+                if (r1 < 0)
+                {
+                    mperr ("*** INTEGER OVERFLOW IN DIVIDE_INTEGER, B TOO LARGE ***");
+                    return new Number.integer (0);
+                }
+            } while (r1 == 0);
+
+            /* ADJUST re_exponent AND GET T+4 DIGITS IN QUOTIENT */
+            z.re_exponent += (int) (1 - i);
+            z.re_fraction[0] = (int) r1;
+            c = BASE * (c - y * r1);
+            int64 kh = 1;
+            if (i < T)
+            {
+                kh = T + 1 - i;
+                for (var k = 1; k < kh; k++)
+                {
+                    c += re_fraction[i];
+                    z.re_fraction[k] = (int) (c / y);
+                    c = BASE * (c - y * z.re_fraction[k]);
+                    i++;
+                }
+                if (c < 0)
+                {
+                    mperr ("*** INTEGER OVERFLOW IN DIVIDE_INTEGER, B TOO LARGE ***");
+                    return new Number.integer (0);
+                }
+            }
+
+            for (var k = kh; k < T + 4; k++)
+            {
+                z.re_fraction[k] = (int) (c / y);
+                c = BASE * (c - y * z.re_fraction[k]);
+            }
+            if (c < 0)
+            {
+                mperr ("*** INTEGER OVERFLOW IN DIVIDE_INTEGER, B TOO LARGE ***");
+                return new Number.integer (0);
+            }
+
+            mp_normalize (ref z);
+            return z;
+        }
+
+        /* HERE NEED SIMULATED DOUBLE-PRECISION DIVISION */
+        var j1 = y / BASE;
+        var j2 = y - j1 * BASE;
+
+        /* LOOK FOR FIRST NONZERO DIGIT */
+        var c2 = 0;
+        do
+        {
+            c = BASE * c + c2;
+            c2 = i < T ? re_fraction[i] : 0;
+            i++;
+        } while (c < j1 || (c == j1 && c2 < j2));
+
+        /* COMPUTE T+4 QUOTIENT DIGITS */
+        z.re_exponent += (int) (1 - i);
+        i--;
+
+        /* MAIN LOOP FOR LARGE ABS (y) CASE */
+        for (var k = 1; k <= T + 4; k++)
+        {
+            /* GET APPROXIMATE QUOTIENT FIRST */
+            var ir = c / (j1 + 1);
+
+            /* NOW REDUCE SO OVERFLOW DOES NOT OCCUR */
+            var iq = c - ir * j1;
+            if (iq >= b2)
+            {
+                /* HERE IQ*B WOULD POSSIBLY OVERFLOW SO INCREASE IR */
+                ir++;
+                iq -= j1;
+            }
+
+            iq = iq * BASE - ir * j2;
+            if (iq < 0)
+            {
+                /* HERE IQ NEGATIVE SO IR WAS TOO LARGE */
+                ir--;
+                iq += y;
+            }
+
+            if (i < T)
+                iq += re_fraction[i];
+            i++;
+            var iqj = iq / y;
+
+            /* r (K) = QUOTIENT, C = REMAINDER */
+            z.re_fraction[k - 1] = (int) (iqj + ir);
+            c = iq - y * iqj;
+
+            if (c < 0)
+            {
+                /* CARRY NEGATIVE SO OVERFLOW MUST HAVE OCCURRED */
+                mperr ("*** INTEGER OVERFLOW IN DIVIDE_INTEGER, B TOO LARGE ***");
+                return new Number.integer (0);
+            }
+        }
+
+        mp_normalize (ref z);
+
+        /* CARRY NEGATIVE SO OVERFLOW MUST HAVE OCCURRED */
+        mperr ("*** INTEGER OVERFLOW IN DIVIDE_INTEGER, B TOO LARGE ***");
+        return new Number.integer (0);
+    }
+
+
+
     private Number from_radians (AngleUnit unit)
     {
         switch (unit)
